"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.monitorConfig = exports.config = void 0;
const types_1 = require("redis-smq-common/dist/types");
const redisHost = process.env.REDIS_HOST || '127.0.0.1';
const redisPort = Number(process.env.REDIS_PORT) || 6379;
const redis = {
    client: types_1.RedisClientName.IOREDIS,
    options: {
        host: redisHost,
        port: redisPort,
        showFriendlyErrorStack: true,
    },
};
const logger = {
    enabled: false,
};
exports.config = {
    redis,
    logger,
    namespace: 'testing',
    messages: {
        store: true,
    },
};
exports.monitorConfig = {
    redis,
    logger,
    server: {
        host: '127.0.0.1',
        port: 3000,
    },
};
//# sourceMappingURL=config.js.map