"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.untilConsumerEvent = exports.untilMessageAcknowledged = exports.consumerOnEvent = void 0;
const redis_smq_1 = require("redis-smq");
function consumerOnEvent(consumer, event) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve) => {
            consumer.once(event, (...args) => {
                resolve(args);
            });
        });
    });
}
exports.consumerOnEvent = consumerOnEvent;
function untilMessageAcknowledged(consumer, msg) {
    return __awaiter(this, void 0, void 0, function* () {
        const [message] = yield consumerOnEvent(consumer, redis_smq_1.events.MESSAGE_ACKNOWLEDGED);
        if (msg && msg.getRequiredId() !== message.getRequiredId()) {
            yield untilMessageAcknowledged(consumer, msg);
        }
    });
}
exports.untilMessageAcknowledged = untilMessageAcknowledged;
function untilConsumerEvent(consumer, event) {
    return __awaiter(this, void 0, void 0, function* () {
        return consumerOnEvent(consumer, event);
    });
}
exports.untilConsumerEvent = untilConsumerEvent;
//# sourceMappingURL=consumer-events.js.map