import { Consumer } from 'redis-smq';
import { IConfig, TConsumerMessageHandler, TQueueParams } from 'redis-smq/dist/types';
declare type TGetConsumerArgs = {
    queue?: string | TQueueParams;
    messageHandler?: TConsumerMessageHandler;
    cfg?: IConfig;
};
export declare function getConsumer(args?: TGetConsumerArgs): {
    consumeAsync: (queue: string | TQueueParams, messageHandler: TConsumerMessageHandler) => Promise<void>;
    cancelAsync: (queue: string | TQueueParams) => Promise<void>;
    runAsync: (() => Promise<false>) | (() => Promise<true>);
    shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
    addListenerAsync: (eventName: string | symbol) => Promise<any>;
    onAsync: (eventName: string | symbol) => Promise<any>;
    onceAsync: (eventName: string | symbol) => Promise<any>;
    removeListenerAsync: (eventName: string | symbol) => Promise<any>;
    offAsync: (eventName: string | symbol) => Promise<any>;
    prependListenerAsync: (eventName: string | symbol) => Promise<any>;
    prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
} & Consumer;
export declare function shutdownConsumers(): Promise<void>;
export {};
