"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = void 0;
const redis_smq_1 = require("redis-smq");
const consumer_message_rate_plugin_1 = require("../../src/plugins/message-rate/consumer-message-rate-plugin");
const producer_message_rate_plugin_1 = require("../../src/plugins/message-rate/producer-message-rate-plugin");
(0, redis_smq_1.registerProducerPlugin)(producer_message_rate_plugin_1.ProducerMessageRatePlugin);
(0, redis_smq_1.registerConsumerPlugin)(consumer_message_rate_plugin_1.ConsumerMessageRatePlugin);
function initialize() {
    return __awaiter(this, void 0, void 0, function* () {
        redis_smq_1.Message.setDefaultConsumeOptions({ retryDelay: 0 });
    });
}
exports.initialize = initialize;
//# sourceMappingURL=initialize.js.map