import { IConfig } from 'redis-smq/dist/types';
import { MessageManager } from 'redis-smq';
export declare function getMessageManager(cfg?: IConfig): Promise<MessageManager>;
export declare function getMessageManagerAsync(cfg?: IConfig): Promise<{
    deadLetteredMessages: {
        purgeAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<void>;
        requeueAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, messageId: string, sequenceId: number) => Promise<void>;
        deleteAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, messageId: string, sequenceId: number) => Promise<void>;
        listAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, skip: number, take: number) => Promise<import("redis-smq/dist/types").TGetMessagesReply>;
        countAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<number>;
    } & import("redis-smq/dist/src/lib/message-manager/dead-lettered-messages").DeadLetteredMessages;
    acknowledgedMessages: {
        listAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, skip: number, take: number) => Promise<import("redis-smq/dist/types").TGetMessagesReply>;
        purgeAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<void>;
        requeueAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, messageId: string, sequenceId: number) => Promise<void>;
        deleteAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, messageId: string, sequenceId: number) => Promise<void>;
        countAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<number>;
    } & import("redis-smq/dist/src/lib/message-manager/acknowledged-messages").AcknowledgedMessages;
    pendingMessages: {
        purgeAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<void>;
        listAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, skip: number, take: number) => Promise<import("redis-smq/dist/types").TGetMessagesReply>;
        deleteAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, messageId: string, sequenceId: number) => Promise<void>;
        countAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<number>;
    } & import("redis-smq/dist/src/lib/message-manager/pending-messages").PendingMessages;
    scheduledMessages: {
        deleteAsync: (messageId: string) => Promise<void>;
        purgeAsync: () => Promise<void>;
        listAsync: (skip: number, take: number) => Promise<import("redis-smq/dist/types").TGetMessagesReply>;
        countAsync: () => Promise<number>;
    } & import("redis-smq/dist/src/lib/message-manager/scheduled-messages").ScheduledMessages;
}>;
export declare function shutdownMessageManager(): Promise<void>;
