"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shutdownMessageManager = exports.getMessageManagerAsync = exports.getMessageManager = void 0;
const config_1 = require("./config");
const bluebird_1 = require("bluebird");
const redis_smq_1 = require("redis-smq");
const MessageManagerAsync = (0, bluebird_1.promisifyAll)(redis_smq_1.MessageManager);
let messageManager = null;
function getMessageManager(cfg = config_1.config) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!messageManager) {
            messageManager = yield MessageManagerAsync.createInstanceAsync(cfg);
        }
        return messageManager;
    });
}
exports.getMessageManager = getMessageManager;
function getMessageManagerAsync(cfg = config_1.config) {
    return __awaiter(this, void 0, void 0, function* () {
        const messageManager = yield getMessageManager(cfg);
        return {
            deadLetteredMessages: (0, bluebird_1.promisifyAll)(messageManager.deadLetteredMessages),
            acknowledgedMessages: (0, bluebird_1.promisifyAll)(messageManager.acknowledgedMessages),
            pendingMessages: (0, bluebird_1.promisifyAll)(messageManager.pendingMessages),
            scheduledMessages: (0, bluebird_1.promisifyAll)(messageManager.scheduledMessages),
        };
    });
}
exports.getMessageManagerAsync = getMessageManagerAsync;
function shutdownMessageManager() {
    return __awaiter(this, void 0, void 0, function* () {
        if (messageManager) {
            yield (0, bluebird_1.promisifyAll)(messageManager).quitAsync();
            messageManager = null;
        }
    });
}
exports.shutdownMessageManager = shutdownMessageManager;
//# sourceMappingURL=message-manager.js.map