import { IConfig, TQueueParams } from 'redis-smq/dist/types';
import { Message } from 'redis-smq';
export declare function createQueue(queue: string | TQueueParams, priorityQueuing: boolean): Promise<void>;
export declare function produceMessageWithPriority(queue?: TQueueParams, cfg?: IConfig): Promise<{
    message: Message;
    producer: {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Producer;
    queue: TQueueParams;
}>;
export declare function produceMessage(queue?: TQueueParams, cfg?: IConfig): Promise<{
    producer: {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Producer;
    message: Message;
    queue: TQueueParams;
}>;
export declare function produceAndDeadLetterMessage(queue?: TQueueParams, cfg?: IConfig): Promise<{
    producer: {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Producer;
    consumer: {
        consumeAsync: (queue: string | TQueueParams, messageHandler: import("redis-smq/dist/types").TConsumerMessageHandler) => Promise<void>;
        cancelAsync: (queue: string | TQueueParams) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Consumer;
    message: Message;
    queue: TQueueParams;
}>;
export declare function produceAndAcknowledgeMessage(queue?: TQueueParams, cfg?: IConfig): Promise<{
    producer: {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Producer;
    consumer: {
        consumeAsync: (queue: string | TQueueParams, messageHandler: import("redis-smq/dist/types").TConsumerMessageHandler) => Promise<void>;
        cancelAsync: (queue: string | TQueueParams) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Consumer;
    queue: TQueueParams;
    message: Message;
}>;
export declare function scheduleMessage(queue?: TQueueParams, cfg?: IConfig): Promise<{
    message: Message;
    producer: {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & {
        produceAsync: (message: Message) => Promise<void>;
        runAsync: (() => Promise<false>) | (() => Promise<true>);
        shutdownAsync: (() => Promise<false>) | (() => Promise<true>);
        addListenerAsync: (eventName: string | symbol) => Promise<any>;
        onAsync: (eventName: string | symbol) => Promise<any>;
        onceAsync: (eventName: string | symbol) => Promise<any>;
        removeListenerAsync: (eventName: string | symbol) => Promise<any>;
        offAsync: (eventName: string | symbol) => Promise<any>;
        prependListenerAsync: (eventName: string | symbol) => Promise<any>;
        prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
    } & import("redis-smq").Producer;
    queue: TQueueParams;
}>;
