"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopMonitorServer = exports.startMonitorServer = void 0;
const __1 = require("../..");
const config_1 = require("./config");
let monitorServer = null;
function startMonitorServer() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!monitorServer) {
            monitorServer = __1.MonitorServer.createInstance(config_1.monitorConfig);
            yield monitorServer.listen();
        }
    });
}
exports.startMonitorServer = startMonitorServer;
function stopMonitorServer() {
    return __awaiter(this, void 0, void 0, function* () {
        if (monitorServer) {
            yield monitorServer.quit();
            monitorServer = null;
        }
    });
}
exports.stopMonitorServer = stopMonitorServer;
//# sourceMappingURL=monitor-server.js.map