"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shutdownProducers = exports.getProducer = void 0;
const config_1 = require("./config");
const redis_smq_1 = require("redis-smq");
const bluebird_1 = require("bluebird");
let producersList = [];
function getProducer(cfg = config_1.config) {
    const producer = new redis_smq_1.Producer(cfg);
    const p = (0, bluebird_1.promisifyAll)(producer);
    producersList.push(p);
    return p;
}
exports.getProducer = getProducer;
function shutdownProducers() {
    return __awaiter(this, void 0, void 0, function* () {
        for (const i of producersList) {
            if (i.isGoingUp()) {
                yield new Promise((resolve) => {
                    i.once(redis_smq_1.events.UP, resolve);
                });
            }
            if (i.isRunning()) {
                yield new Promise((resolve) => {
                    i.shutdown(resolve);
                });
            }
        }
        producersList = [];
    });
}
exports.shutdownProducers = shutdownProducers;
//# sourceMappingURL=producers.js.map