import { IConfig } from 'redis-smq/dist/types';
import { QueueManager } from 'redis-smq';
export declare function getQueueManager(cfg?: IConfig): Promise<QueueManager>;
export declare function getQueueManagerAsync(cfg?: IConfig): Promise<{
    queue: {
        createAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, priorityQueuing: boolean) => Promise<void>;
        getSettingsAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<import("redis-smq/dist/types").TQueueSettings>;
        existsAsync: ((queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<false>) | ((queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<true>);
        listAsync: () => Promise<import("redis-smq/dist/types").TQueueParams[]>;
        deleteAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<void>;
    } & import("redis-smq/dist/src/lib/queue-manager/queue").Queue;
    namespace: {
        listAsync: () => Promise<string[]>;
        getQueuesAsync: (namespace: string) => Promise<import("redis-smq/dist/types").TQueueParams[]>;
        deleteAsync: (ns: string) => Promise<void>;
    } & import("redis-smq/dist/src/lib/queue-manager/namespace").Namespace;
    queueRateLimit: {
        clearAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<void>;
        setAsync: (queue: string | import("redis-smq/dist/types").TQueueParams, rateLimit: import("redis-smq/dist/types").TQueueRateLimit) => Promise<void>;
        getAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<import("redis-smq/dist/types").TQueueRateLimit>;
    } & import("redis-smq/dist/src/lib/queue-manager/queue-rate-limit").QueueRateLimit;
    queueMetrics: {
        getMetricsAsync: (queue: string | import("redis-smq/dist/types").TQueueParams) => Promise<import("redis-smq/dist/types").IQueueMetrics>;
    } & import("redis-smq/dist/src/lib/queue-manager/queue-metrics").QueueMetrics;
}>;
export declare function shutdownQueueManager(): Promise<void>;
