"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shutdownQueueManager = exports.getQueueManagerAsync = exports.getQueueManager = void 0;
const config_1 = require("./config");
const bluebird_1 = require("bluebird");
const redis_smq_1 = require("redis-smq");
const QueueManagerAsync = (0, bluebird_1.promisifyAll)(redis_smq_1.QueueManager);
let queueManager = null;
function getQueueManager(cfg = config_1.config) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!queueManager) {
            queueManager = yield QueueManagerAsync.createInstanceAsync(cfg);
        }
        return queueManager;
    });
}
exports.getQueueManager = getQueueManager;
function getQueueManagerAsync(cfg = config_1.config) {
    return __awaiter(this, void 0, void 0, function* () {
        const queueManager = yield getQueueManager(cfg);
        const queue = (0, bluebird_1.promisifyAll)(queueManager.queue);
        const namespace = (0, bluebird_1.promisifyAll)(queueManager.namespace);
        const queueRateLimit = (0, bluebird_1.promisifyAll)(queueManager.queueRateLimit);
        const queueMetrics = (0, bluebird_1.promisifyAll)(queueManager.queueMetrics);
        return {
            queue,
            namespace,
            queueRateLimit,
            queueMetrics,
        };
    });
}
exports.getQueueManagerAsync = getQueueManagerAsync;
function shutdownQueueManager() {
    return __awaiter(this, void 0, void 0, function* () {
        if (queueManager) {
            const q = (0, bluebird_1.promisifyAll)(queueManager);
            yield q.quitAsync();
            queueManager = null;
        }
    });
}
exports.shutdownQueueManager = shutdownQueueManager;
//# sourceMappingURL=queue-manager.js.map