import { RedisClient } from 'redis-smq-common';
export declare function getRedisInstance(): Promise<{
    zaddAsync: ((key: string, score: number, member: string) => Promise<string>) | ((key: string, score: number, member: string) => Promise<number>);
    watchAsync: (args: string[]) => Promise<string>;
    unwatchAsync: () => Promise<string>;
    execMultiAsync: (multi: import("redis-smq-common/dist/types").TRedisClientMulti) => Promise<unknown[]>;
    sismemberAsync: (key: string, member: string) => Promise<number>;
    existsAsync: ((key: string) => Promise<false>) | ((key: string) => Promise<true>);
    zcardAsync: (key: string) => Promise<number>;
    zrangeAsync: (key: string, min: number, max: number) => Promise<string[]>;
    zrevrangeAsync: (key: string, min: number, max: number) => Promise<string[]>;
    onAsync: (event: string) => Promise<string>;
    zrangebyscoreAsync: (key: string, min: string | number, max: string | number) => Promise<string[]>;
    smembersAsync: (key: string) => Promise<string[]>;
    saddAsync: (key: string, member: string) => Promise<number>;
    hgetallAsync: (key: string) => Promise<Record<string, string>>;
    hgetAsync: (key: string, field: string) => Promise<string>;
    hsetAsync: (key: string, field: string, value: string) => Promise<number>;
    hdelAsync: (key: string, fields: string | string[]) => Promise<number>;
    lrangeAsync: (key: string, start: number, stop: number) => Promise<string[]>;
    hkeysAsync: (key: string) => Promise<string[]>;
    hlenAsync: (key: string) => Promise<number>;
    hmsetAsync: (key: string, args: (string | number)[]) => Promise<string>;
    hsetnxAsync: (key: string, field: string, value: string) => Promise<number>;
    brpoplpushAsync: (source: string, destination: string, timeout: number) => Promise<string>;
    rpoplpushAsync: (source: string, destination: string) => Promise<string>;
    zpoprpushAsync: (source: string, destination: string) => Promise<string>;
    zpophgetrpushAsync: (source: string, sourceHash: string, destination: string) => Promise<string>;
    zrangebyscorewithscoresAsync: (source: string, max: number, min: number) => Promise<Record<string, string>>;
    zpushhsetAsync: (sortedSet: string, hash: string, score: number, keyId: string, keyValue: string) => Promise<void>;
    zremAsync: (key: string, value: string | string[]) => Promise<string>;
    rpopAsync: (key: string) => Promise<string>;
    lpushAsync: (key: string, element: string) => Promise<number>;
    rpushAsync: (key: string, element: string) => Promise<number>;
    lremAsync: (key: string, count: number, element: string) => Promise<number>;
    publishAsync: (channel: string, message: string) => Promise<number>;
    flushallAsync: () => Promise<string>;
    evalAsync: () => Promise<unknown>;
    loadScriptAsync: (script: string) => Promise<string>;
    evalshaAsync: (hash: string, args: string | number | (string | number)[]) => Promise<unknown>;
    getAsync: (key: string) => Promise<string>;
    setAsync: (key: string, value: string, expiryMode: "EX" | "PX" | undefined, time: number | undefined, flag: string | undefined) => Promise<string>;
    delAsync: (key: string | string[]) => Promise<number>;
    llenAsync: (key: string) => Promise<number>;
    lmoveAsync: (source: string, destination: string, from: "LEFT" | "RIGHT", to: "LEFT" | "RIGHT") => Promise<string>;
    lpoprpushextraAsync: (source: string, destination: string, listSize: number, expire: number) => Promise<string>;
    lpoprpushAsync: (source: string, destination: string) => Promise<string>;
    loadScriptsAsync: () => Promise<void>;
    runScriptAsync: (scriptName: string, keys: string[], args: (string | number)[]) => Promise<unknown>;
    zremrangebyscoreAsync: (source: string, min: string | number, max: string | number) => Promise<number>;
    hmgetAsync: (source: string, keys: string[]) => Promise<(string | null)[]>;
    hexistsAsync: ((source: string, key: string) => Promise<false>) | ((source: string, key: string) => Promise<true>);
    haltAsync: () => Promise<void>;
    quitAsync: () => Promise<void>;
    updateServerVersionAsync: () => Promise<void>;
    addListenerAsync: (eventName: string | symbol) => Promise<any>;
    onceAsync: (eventName: string | symbol) => Promise<any>;
    removeListenerAsync: (eventName: string | symbol) => Promise<any>;
    offAsync: (eventName: string | symbol) => Promise<any>;
    prependListenerAsync: (eventName: string | symbol) => Promise<any>;
    prependOnceListenerAsync: (eventName: string | symbol) => Promise<any>;
} & RedisClient>;
export declare function shutdownRedisClients(): Promise<void>;
