"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shutdownRedisClients = exports.getRedisInstance = void 0;
const redis_smq_common_1 = require("redis-smq-common");
const bluebird_1 = require("bluebird");
const config_1 = require("./config");
const types_1 = require("redis-smq-common/dist/types");
const redisClients = [];
function getRedisInstance() {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const RedisClientAsync = (0, bluebird_1.promisifyAll)(redis_smq_common_1.RedisClient);
        const c = (0, bluebird_1.promisifyAll)(yield RedisClientAsync.getNewInstanceAsync((_a = config_1.config.redis) !== null && _a !== void 0 ? _a : { client: types_1.RedisClientName.REDIS }));
        redisClients.push(c);
        return c;
    });
}
exports.getRedisInstance = getRedisInstance;
function shutdownRedisClients() {
    return __awaiter(this, void 0, void 0, function* () {
        while (redisClients.length) {
            const redisClient = redisClients.pop();
            if (redisClient) {
                yield (0, bluebird_1.promisifyAll)(redisClient).haltAsync();
            }
        }
    });
}
exports.shutdownRedisClients = shutdownRedisClients;
//# sourceMappingURL=redis-clients.js.map