"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shutDown = void 0;
const message_manager_1 = require("./message-manager");
const queue_manager_1 = require("./queue-manager");
const redis_clients_1 = require("./redis-clients");
const consumers_1 = require("./consumers");
const producers_1 = require("./producers");
const monitor_server_1 = require("./monitor-server");
const time_series_clean_up_worker_1 = require("./time-series-clean-up-worker");
const websocket_heartbeat_stream_worker_1 = require("./websocket-heartbeat-stream-worker");
const websocket_main_stream_worker_1 = require("./websocket-main-stream-worker");
const websocket_online_stream_worker_1 = require("./websocket-online-stream-worker");
const websocket_rate_stream_worker_1 = require("./websocket-rate-stream-worker");
function shutDown() {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, monitor_server_1.stopMonitorServer)();
        yield (0, time_series_clean_up_worker_1.stopTimeSeriesWorker)();
        yield (0, websocket_heartbeat_stream_worker_1.stopWebsocketHeartbeatStreamWorker)();
        yield (0, websocket_main_stream_worker_1.stopWebsocketMainStreamWorker)();
        yield (0, websocket_online_stream_worker_1.stopWebsocketOnlineStreamWorker)();
        yield (0, websocket_rate_stream_worker_1.stopWebsocketRateStreamWorker)();
        yield (0, consumers_1.shutdownConsumers)();
        yield (0, producers_1.shutdownProducers)();
        yield (0, message_manager_1.shutdownMessageManager)();
        yield (0, queue_manager_1.shutdownQueueManager)();
        yield (0, redis_clients_1.shutdownRedisClients)();
    });
}
exports.shutDown = shutDown;
//# sourceMappingURL=shut-down.js.map