"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopTimeSeriesWorker = exports.startTimeSeriesWorker = void 0;
const time_series_clean_up_worker_1 = require("../../src/workers/time-series.clean-up.worker");
const redis_clients_1 = require("./redis-clients");
const queue_manager_1 = require("./queue-manager");
let timeSeriesCleanUpWorker = null;
function startTimeSeriesWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!timeSeriesCleanUpWorker) {
            const redisClient = yield (0, redis_clients_1.getRedisInstance)();
            const queueManager = yield (0, queue_manager_1.getQueueManager)();
            timeSeriesCleanUpWorker = new time_series_clean_up_worker_1.default(redisClient, queueManager, false);
            timeSeriesCleanUpWorker.run();
        }
    });
}
exports.startTimeSeriesWorker = startTimeSeriesWorker;
function stopTimeSeriesWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve) => {
            if (timeSeriesCleanUpWorker) {
                timeSeriesCleanUpWorker.quit(() => {
                    timeSeriesCleanUpWorker = null;
                    resolve();
                });
            }
            else
                resolve();
        });
    });
}
exports.stopTimeSeriesWorker = stopTimeSeriesWorker;
//# sourceMappingURL=time-series-clean-up-worker.js.map