import * as supertest from 'supertest';
import { TTimeSeriesRange } from '../../types';
export interface ISuperTestResponse<TData> extends supertest.Response {
    body: {
        data?: TData;
        error?: {
            code: string;
            message: string;
            details: Record<string, any>;
        };
    };
}
export declare function listenForWebsocketStreamEvents<TPayload = TTimeSeriesRange>(streamName: string, startFn?: () => Promise<void>): Promise<{
    ts: number;
    payload: TPayload;
}[]>;
export declare function validateTimeSeriesFrom(url: string): Promise<void>;
