"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopWebsocketHeartbeatStreamWorker = exports.startWebsocketHeartbeatStreamWorker = void 0;
const websocket_heartbeat_stream_worker_1 = require("../../src/workers/websocket-heartbeat-stream.worker");
const redis_clients_1 = require("./redis-clients");
let websocketHeartbeatStreamWorker = null;
function startWebsocketHeartbeatStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!websocketHeartbeatStreamWorker) {
            const redisClient = yield (0, redis_clients_1.getRedisInstance)();
            websocketHeartbeatStreamWorker = new websocket_heartbeat_stream_worker_1.default(redisClient, false);
            websocketHeartbeatStreamWorker.run();
        }
    });
}
exports.startWebsocketHeartbeatStreamWorker = startWebsocketHeartbeatStreamWorker;
function stopWebsocketHeartbeatStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve) => {
            if (websocketHeartbeatStreamWorker) {
                websocketHeartbeatStreamWorker.quit(() => {
                    websocketHeartbeatStreamWorker = null;
                    resolve();
                });
            }
            else
                resolve();
        });
    });
}
exports.stopWebsocketHeartbeatStreamWorker = stopWebsocketHeartbeatStreamWorker;
//# sourceMappingURL=websocket-heartbeat-stream-worker.js.map