"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopWebsocketMainStreamWorker = exports.startWebsocketMainStreamWorker = void 0;
const websocket_main_stream_worker_1 = require("../../src/workers/websocket-main-stream.worker");
const redis_clients_1 = require("./redis-clients");
const message_manager_1 = require("./message-manager");
const queue_manager_1 = require("./queue-manager");
let websocketMainStreamWorker = null;
function startWebsocketMainStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!websocketMainStreamWorker) {
            const redisClient = yield (0, redis_clients_1.getRedisInstance)();
            const queueManager = yield (0, queue_manager_1.getQueueManager)();
            const messageManager = yield (0, message_manager_1.getMessageManager)();
            websocketMainStreamWorker = new websocket_main_stream_worker_1.default(redisClient, messageManager, queueManager, false);
            websocketMainStreamWorker.run();
        }
    });
}
exports.startWebsocketMainStreamWorker = startWebsocketMainStreamWorker;
function stopWebsocketMainStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve) => {
            if (websocketMainStreamWorker) {
                websocketMainStreamWorker.quit(() => {
                    websocketMainStreamWorker = null;
                    resolve();
                });
            }
            else
                resolve();
        });
    });
}
exports.stopWebsocketMainStreamWorker = stopWebsocketMainStreamWorker;
//# sourceMappingURL=websocket-main-stream-worker.js.map