"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopWebsocketRateStreamWorker = exports.startWebsocketRateStreamWorker = void 0;
const websocket_rate_stream_worker_1 = require("../../src/workers/websocket-rate-stream.worker");
const redis_clients_1 = require("./redis-clients");
const queue_manager_1 = require("./queue-manager");
let websocketRateStreamWorker = null;
function startWebsocketRateStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        if (!websocketRateStreamWorker) {
            const redisClient = yield (0, redis_clients_1.getRedisInstance)();
            const queueManager = yield (0, queue_manager_1.getQueueManager)();
            websocketRateStreamWorker = new websocket_rate_stream_worker_1.default(redisClient, queueManager, false);
            websocketRateStreamWorker.run();
        }
    });
}
exports.startWebsocketRateStreamWorker = startWebsocketRateStreamWorker;
function stopWebsocketRateStreamWorker() {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve) => {
            if (websocketRateStreamWorker) {
                websocketRateStreamWorker.quit(() => {
                    websocketRateStreamWorker = null;
                    resolve();
                });
            }
            else
                resolve();
        });
    });
}
exports.stopWebsocketRateStreamWorker = stopWebsocketRateStreamWorker;
//# sourceMappingURL=websocket-rate-stream-worker.js.map