"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supertest = require("supertest");
const redis_smq_1 = require("redis-smq");
const monitor_server_1 = require("../../common/monitor-server");
const message_producing_1 = require("../../common/message-producing");
const producers_1 = require("../../common/producers");
const common_1 = require("../../common/common");
test('Fetching and deleting scheduled messages using the HTTP API: Case 2', () => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    yield (0, monitor_server_1.startMonitorServer)();
    yield (0, message_producing_1.createQueue)(common_1.defaultQueue, false);
    const producer = (0, producers_1.getProducer)();
    const messages = [];
    for (let i = 0; i < 4; i += 1) {
        const msg = new redis_smq_1.Message();
        msg
            .setScheduledDelay(60000 * (i + 1))
            .setBody({ hello: `world ${i}` })
            .setQueue(common_1.defaultQueue);
        yield producer.produceAsync(msg);
        messages.push(msg);
    }
    const request = supertest('http://127.0.0.1:3000');
    const response1 = yield request.get('/api/main/scheduled-messages?skip=0&take=2');
    expect(response1.statusCode).toBe(200);
    expect(response1.body.data).toBeDefined();
    expect((_a = response1.body.data) === null || _a === void 0 ? void 0 : _a.total).toBe(4);
    expect((_b = response1.body.data) === null || _b === void 0 ? void 0 : _b.items.length).toBe(2);
    expect((_d = (_c = response1.body.data) === null || _c === void 0 ? void 0 : _c.items[0].message.metadata) === null || _d === void 0 ? void 0 : _d.uuid).toBe(messages[0].getRequiredId());
    expect((_f = (_e = response1.body.data) === null || _e === void 0 ? void 0 : _e.items[1].message.metadata) === null || _f === void 0 ? void 0 : _f.uuid).toBe(messages[1].getRequiredId());
    const response2 = yield request.get('/api/main/scheduled-messages?skip=2&take=2');
    expect(response2.statusCode).toBe(200);
    expect(response2.body.data).toBeDefined();
    expect((_g = response2.body.data) === null || _g === void 0 ? void 0 : _g.total).toBe(4);
    expect((_h = response2.body.data) === null || _h === void 0 ? void 0 : _h.items.length).toBe(2);
    expect((_k = (_j = response2.body.data) === null || _j === void 0 ? void 0 : _j.items[0].message.metadata) === null || _k === void 0 ? void 0 : _k.uuid).toBe(messages[2].getRequiredId());
    expect((_m = (_l = response2.body.data) === null || _l === void 0 ? void 0 : _l.items[1].message.metadata) === null || _m === void 0 ? void 0 : _m.uuid).toBe(messages[3].getRequiredId());
    const response3 = yield request.get('/api/main/scheduled-messages?skip=4&take=2');
    expect(response3.statusCode).toBe(200);
    expect(response3.body.data).toBeDefined();
    expect((_o = response3.body.data) === null || _o === void 0 ? void 0 : _o.total).toBe(4);
    expect((_p = response3.body.data) === null || _p === void 0 ? void 0 : _p.items.length).toBe(0);
}));
//# sourceMappingURL=test00002.test.js.map