"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supertest = require("supertest");
const monitor_server_1 = require("../../common/monitor-server");
test('Fetching and deleting scheduled messages using the HTTP API: Case 3', () => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d;
    yield (0, monitor_server_1.startMonitorServer)();
    const request = supertest('http://127.0.0.1:3000');
    const response1 = yield request.get('/api/main/scheduled-messages?skip=a');
    expect(response1.statusCode).toBe(422);
    expect(response1.body.data).toBeUndefined();
    expect(response1.body.error).toBeDefined();
    expect((_a = response1.body.error) === null || _a === void 0 ? void 0 : _a.code).toBe(422);
    expect(Object.keys((_b = response1.body.error) !== null && _b !== void 0 ? _b : {})).toEqual(expect.arrayContaining(['code', 'message', 'details']));
    expect(Object.keys((_d = (_c = response1.body.error) === null || _c === void 0 ? void 0 : _c.details) !== null && _d !== void 0 ? _d : {})).toEqual(expect.arrayContaining(['target', 'property', 'children', 'constraints']));
}));
//# sourceMappingURL=test00003.test.js.map