"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supertest = require("supertest");
const monitor_server_1 = require("../../common/monitor-server");
const message_producing_1 = require("../../common/message-producing");
const common_1 = require("../../common/common");
test('Fetching queues, namespaces, queue namespaces, deleting namespace', () => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    yield (0, monitor_server_1.startMonitorServer)();
    yield (0, message_producing_1.createQueue)(common_1.defaultQueue, false);
    const { message } = yield (0, message_producing_1.produceMessage)();
    const request = supertest('http://127.0.0.1:3000');
    const r1 = yield request.get('/api/queues');
    expect(r1.statusCode).toBe(200);
    expect(r1.body.data).toBeDefined();
    expect((_a = r1.body.data) === null || _a === void 0 ? void 0 : _a.length).toBe(1);
    expect(((_b = r1.body.data) !== null && _b !== void 0 ? _b : [])[0]).toEqual(message.getRequiredQueue());
    const r2 = yield request.get('/api/ns');
    expect(r2.statusCode).toBe(200);
    expect(r2.body.data).toBeDefined();
    expect((_c = r2.body.data) === null || _c === void 0 ? void 0 : _c.length).toBe(1);
    expect(((_d = r2.body.data) !== null && _d !== void 0 ? _d : [])[0]).toEqual(message.getRequiredQueue().ns);
    const r3 = yield request.get(`/api/ns/${message.getRequiredQueue().ns}/queues`);
    expect(r3.statusCode).toBe(200);
    expect(r3.body.data).toBeDefined();
    expect((_e = r3.body.data) === null || _e === void 0 ? void 0 : _e.length).toBe(1);
    expect(((_f = r3.body.data) !== null && _f !== void 0 ? _f : [])[0]).toEqual(message.getRequiredQueue());
    const r4 = yield request.delete(`/api/ns/${message.getRequiredQueue().ns}`);
    expect(r4.status).toEqual(204);
    expect(r4.body.data).toBeUndefined();
    const r5 = yield request.get('/api/queues');
    expect(r5.statusCode).toBe(200);
    expect((_g = r5.body.data) === null || _g === void 0 ? void 0 : _g.length).toBe(0);
    const r6 = yield request.get('/api/ns');
    expect(r6.statusCode).toBe(200);
    expect((_h = r6.body.data) === null || _h === void 0 ? void 0 : _h.length).toBe(0);
    const r7 = yield request.get(`/api/ns/${message.getRequiredQueue().ns}/queues`);
    expect(r7.statusCode).toBe(200);
    expect((_j = r7.body.data) === null || _j === void 0 ? void 0 : _j.length).toBe(0);
}));
//# sourceMappingURL=test00006.test.js.map