"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supertest = require("supertest");
const monitor_server_1 = require("../../common/monitor-server");
const message_producing_1 = require("../../common/message-producing");
const common_1 = require("../../common/common");
test('Requeuing a dead-lettered messages', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, monitor_server_1.startMonitorServer)();
    yield (0, message_producing_1.createQueue)(common_1.defaultQueue, false);
    const { message, queue } = yield (0, message_producing_1.produceAndDeadLetterMessage)();
    const request = supertest('http://127.0.0.1:3000');
    const response1 = yield request.post(`/api/ns/${queue.ns}/queues/${queue.name}/dead-lettered-messages/${message.getRequiredId()}/requeue?sequenceId=0`);
    expect(response1.statusCode).toBe(204);
    expect(response1.body).toEqual({});
}));
//# sourceMappingURL=test00016.test.js.map