"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supertest = require("supertest");
const monitor_server_1 = require("../../common/monitor-server");
const common_1 = require("../../common/common");
test('Set a queue message consumption rate limit and retrieve a the queue rate limit', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, monitor_server_1.startMonitorServer)();
    const request = supertest('http://127.0.0.1:3000');
    const response1 = yield request
        .post(`/api/ns/${common_1.defaultQueue.ns}/queues/${common_1.defaultQueue.name}/rate-limit`)
        .send({ interval: 10000, limit: 3 });
    expect(response1.statusCode).toBe(204);
    expect(response1.body).toEqual({});
    const response2 = yield request.get(`/api/ns/${common_1.defaultQueue.ns}/queues/${common_1.defaultQueue.name}/rate-limit`);
    expect(response2.statusCode).toBe(200);
    expect(response2.body.data).toEqual({ interval: 10000, limit: 3 });
    const response3 = yield request.get(`/api/ns/${common_1.defaultQueue.ns}/queues/my-queue/rate-limit`);
    expect(response3.statusCode).toBe(200);
    expect(response3.body.data).toEqual(null);
}));
//# sourceMappingURL=test00036.test.js.map