"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const bluebird_1 = require("bluebird");
const producer_message_rate_writer_1 = require("../../../src/plugins/message-rate/producer/producer-message-rate-writer");
const producer_message_rate_1 = require("../../../src/plugins/message-rate/producer/producer-message-rate");
const redis_clients_1 = require("../../common/redis-clients");
test('ProducerMessageRate/ProducerMessageRateWriter: case 1', () => __awaiter(void 0, void 0, void 0, function* () {
    const redisClient = yield (0, redis_clients_1.getRedisInstance)();
    const messageRateWriter = (0, bluebird_1.promisifyAll)(new producer_message_rate_writer_1.ProducerMessageRateWriter(redisClient));
    const messageRate = (0, bluebird_1.promisifyAll)(new producer_message_rate_1.ProducerMessageRate(messageRateWriter));
    const r = yield new Promise((resolve) => {
        const orig = messageRateWriter.onUpdate;
        messageRateWriter.onUpdate = function (ts, rateFields, cb) {
            orig.call(this, ts, rateFields, (err) => {
                cb(err);
                messageRateWriter.onUpdate = orig;
                resolve({ ts, rateFields });
            });
        };
    });
    expect(typeof r.ts).toBe('number');
    expect(typeof r.rateFields.publishedRate).toBe('number');
    expect(r.rateFields.queuePublishedRate).toEqual({});
    messageRate.incrementPublished({ ns: 'testing', name: 'test_queue' });
    const r2 = yield new Promise((resolve) => {
        const orig = messageRateWriter.onUpdate;
        messageRateWriter.onUpdate = function (ts, rateFields, cb) {
            orig.call(this, ts, rateFields, (err) => {
                cb(err);
                messageRateWriter.onUpdate = orig;
                resolve({ ts, rateFields });
            });
        };
    });
    expect(typeof r2.ts).toBe('number');
    expect(typeof r2.rateFields.publishedRate).toBe('number');
    expect(typeof r2.rateFields.queuePublishedRate[`testing:test_queue`]).toEqual('number');
    yield messageRate.quitAsync();
}));
//# sourceMappingURL=test00012.test.js.map