"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const bluebird_1 = require("bluebird");
const redis_clients_1 = require("../../common/redis-clients");
const hash_time_series_1 = require("../../../src/plugins/message-rate/common/hash-time-series");
const time_series_1 = require("../../../src/plugins/message-rate/common/time-series");
test('HashTimeSeries: Case 4', () => __awaiter(void 0, void 0, void 0, function* () {
    const redisClient = yield (0, redis_clients_1.getRedisInstance)();
    const hashTimeSeries = (0, bluebird_1.promisifyAll)(new hash_time_series_1.HashTimeSeries(redisClient, {
        key: 'my-key',
        indexKey: 'my-key-index',
        expireAfterInSeconds: 5,
        retentionTimeInSeconds: 20,
    }));
    const ts = time_series_1.TimeSeries.getCurrentTimestamp();
    for (let i = 0; i < 10; i += 1) {
        yield hashTimeSeries.addAsync(ts + i, i);
    }
    yield (0, bluebird_1.delay)(10000);
    yield hashTimeSeries.cleanUpAsync();
    const range1 = yield hashTimeSeries.getRangeAsync(ts, ts + 10);
    expect(range1.length).toEqual(10);
    expect(range1[0]).toEqual({ timestamp: ts, value: 0 });
    expect(range1[1]).toEqual({ timestamp: ts + 1, value: 0 });
    expect(range1[2]).toEqual({ timestamp: ts + 2, value: 0 });
    expect(range1[3]).toEqual({ timestamp: ts + 3, value: 0 });
    expect(range1[4]).toEqual({ timestamp: ts + 4, value: 0 });
    expect(range1[5]).toEqual({ timestamp: ts + 5, value: 0 });
    expect(range1[6]).toEqual({ timestamp: ts + 6, value: 0 });
    expect(range1[7]).toEqual({ timestamp: ts + 7, value: 0 });
    expect(range1[8]).toEqual({ timestamp: ts + 8, value: 0 });
    expect(range1[9]).toEqual({ timestamp: ts + 9, value: 0 });
}));
//# sourceMappingURL=test00008.test.js.map