"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const bluebird_1 = require("bluebird");
const queue_manager_1 = require("../../common/queue-manager");
const time_series_clean_up_worker_1 = require("../../common/time-series-clean-up-worker");
const common_1 = require("../../common/common");
const consumers_1 = require("../../common/consumers");
test('TimeSeriesWorker', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, time_series_clean_up_worker_1.startTimeSeriesWorker)();
    yield (0, bluebird_1.delay)(5000);
    const queueManager = yield (0, queue_manager_1.getQueueManagerAsync)();
    queueManager.queue.createAsync(common_1.defaultQueue, false);
    yield (0, bluebird_1.delay)(5000);
    const consumer = yield (0, consumers_1.getConsumer)({ queue: common_1.defaultQueue });
    yield consumer.runAsync();
    yield (0, bluebird_1.delay)(5000);
}));
//# sourceMappingURL=test00016.test.js.map