"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const websocket_main_stream_worker_1 = require("../../common/websocket-main-stream-worker");
const redis_clients_1 = require("../../common/redis-clients");
test('WebsocketMainStreamWorker: Case 1', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, websocket_main_stream_worker_1.startWebsocketMainStreamWorker)();
    const subscribeClient = yield (0, redis_clients_1.getRedisInstance)();
    subscribeClient.subscribe('streamMain');
    const json = yield new Promise((resolve) => {
        subscribeClient.on('message', (channel, message) => {
            const json = JSON.parse(message);
            resolve(json);
        });
    });
    expect(json).toEqual({
        scheduledMessagesCount: 0,
        deadLetteredMessagesCount: 0,
        pendingMessagesCount: 0,
        acknowledgedMessagesCount: 0,
        consumersCount: 0,
        queuesCount: 0,
        queues: {},
    });
}));
//# sourceMappingURL=test00001.test.js.map