"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const websocket_main_stream_worker_1 = require("../../common/websocket-main-stream-worker");
const redis_clients_1 = require("../../common/redis-clients");
const message_producing_1 = require("../../common/message-producing");
const consumers_1 = require("../../common/consumers");
const common_1 = require("../../common/common");
test('WebsocketMainStreamWorker: Case 2', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, message_producing_1.createQueue)(common_1.defaultQueue, false);
    const consumer = (0, consumers_1.getConsumer)();
    yield consumer.runAsync();
    yield (0, websocket_main_stream_worker_1.startWebsocketMainStreamWorker)();
    const subscribeClient = yield (0, redis_clients_1.getRedisInstance)();
    subscribeClient.subscribe('streamMain');
    const json = yield new Promise((resolve) => {
        subscribeClient.on('message', (channel, message) => {
            const json = JSON.parse(message);
            resolve(json);
        });
    });
    expect(json).toEqual({
        scheduledMessagesCount: 0,
        deadLetteredMessagesCount: 0,
        pendingMessagesCount: 0,
        acknowledgedMessagesCount: 0,
        consumersCount: 1,
        queuesCount: 1,
        queues: {
            testing: {
                test_queue: {
                    name: 'test_queue',
                    ns: 'testing',
                    priorityQueuing: false,
                    rateLimit: null,
                    deadLetteredMessagesCount: 0,
                    acknowledgedMessagesCount: 0,
                    pendingMessagesCount: 0,
                    consumersCount: 1,
                },
            },
        },
    });
}));
//# sourceMappingURL=test00002.test.js.map