"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common/common");
const message_producing_1 = require("../../common/message-producing");
const websocket_event_1 = require("../../common/websocket-event");
const consumers_1 = require("../../common/consumers");
const websocket_online_stream_worker_1 = require("../../common/websocket-online-stream-worker");
const common_2 = require("../../common/common");
test('WebsocketOnlineStreamWorker: streamOnlineQueueConsumers/case 1', () => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, message_producing_1.createQueue)(common_2.defaultQueue, false);
    const consumer = (0, consumers_1.getConsumer)();
    yield consumer.runAsync();
    const data = yield (0, websocket_event_1.listenForWebsocketStreamEvents)(`streamOnlineQueueConsumers:${common_2.defaultQueue.ns}:${common_2.defaultQueue.name}`, websocket_online_stream_worker_1.startWebsocketOnlineStreamWorker);
    for (let i = 0; i < data.length; i += 1) {
        const diff = data[i].ts - data[0].ts;
        expect((0, common_1.validateTime)(diff, 1000 * i)).toBe(true);
        expect(Object.keys(data[i].payload)).toEqual([consumer.getId()]);
        const payload = JSON.parse(data[i].payload[consumer.getId()]);
        expect(Object.keys(payload)).toEqual([
            'ipAddress',
            'hostname',
            'pid',
            'createdAt',
        ]);
    }
}));
//# sourceMappingURL=test00017.test.js.map